/**
 * Copyright (c) 2016, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the "hack" directory of this source tree. An additional
 * directory.
 *
 **
 *
 * THIS FILE IS @generated; DO NOT EDIT IT
 * To regenerate this file, run
 *
 *   buck run //hphp/hack/src:generate_full_fidelity
 *
 **
 *
 */

use std::num::NonZeroUsize;

use ocamlrep_derive::{FromOcamlRep, ToOcamlRep};

#[allow(non_camel_case_types)] // allow Include_once and Require_once
#[derive(Debug, Copy, Clone, PartialEq, Ord, Eq, PartialOrd, FromOcamlRep, ToOcamlRep)]
#[repr(u8)]
pub enum TokenKind {
    // No text tokens
    EndOfFile = 0,
    // Given text tokens
    Abstract = 1,
    Arraykey = 2,
    As = 3,
    Async = 4,
    Attribute = 5,
    Await = 6,
    Backslash = 7,
    Binary = 8,
    Bool = 9,
    Boolean = 10,
    Break = 11,
    Case = 12,
    Catch = 13,
    Category = 14,
    Children = 15,
    Class = 16,
    Classname = 17,
    Clone = 18,
    Const = 19,
    Construct = 20,
    Continue = 21,
    Ctx = 22,
    Darray = 23,
    Default = 24,
    Define = 25,
    Dict = 26,
    Do = 27,
    Double = 28,
    Echo = 29,
    Else = 30,
    Empty = 31,
    Endfor = 32,
    Endforeach = 33,
    Endif = 34,
    Endswitch = 35,
    Endwhile = 36,
    Enum = 37,
    Eval = 38,
    Extends = 39,
    Fallthrough = 40,
    Float = 41,
    File = 42,
    Final = 43,
    Finally = 44,
    For = 45,
    Foreach = 46,
    From = 47,
    Function = 48,
    Global = 49,
    Concurrent = 50,
    If = 51,
    Implements = 52,
    Include = 53,
    Include_once = 54,
    Inout = 55,
    Instanceof = 56,
    Insteadof = 57,
    Int = 58,
    Integer = 59,
    Interface = 60,
    Is = 61,
    Isset = 62,
    Keyset = 63,
    List = 64,
    Mixed = 65,
    Module = 66,
    Namespace = 67,
    New = 68,
    Newctx = 69,
    Newtype = 70,
    Noreturn = 71,
    Num = 72,
    Parent = 73,
    Print = 74,
    Private = 75,
    Protected = 76,
    Public = 77,
    Real = 78,
    Reify = 79,
    Require = 80,
    Require_once = 81,
    Required = 82,
    Lateinit = 83,
    Resource = 84,
    Return = 85,
    SelfToken = 86,
    Shape = 87,
    Static = 88,
    String = 89,
    Super = 90,
    Switch = 91,
    This = 92,
    Throw = 93,
    Trait = 94,
    Try = 95,
    Tuple = 96,
    Type = 97,
    Unset = 98,
    Upcast = 99,
    Use = 100,
    Using = 101,
    Var = 102,
    Varray = 103,
    Vec = 104,
    Void = 105,
    With = 106,
    Where = 107,
    While = 108,
    Yield = 109,
    NullLiteral = 110,
    LeftBracket = 111,
    RightBracket = 112,
    LeftParen = 113,
    RightParen = 114,
    LeftBrace = 115,
    RightBrace = 116,
    Dot = 117,
    MinusGreaterThan = 118,
    PlusPlus = 119,
    MinusMinus = 120,
    StarStar = 121,
    Star = 122,
    Plus = 123,
    Minus = 124,
    Tilde = 125,
    Exclamation = 126,
    Dollar = 127,
    Slash = 128,
    Percent = 129,
    LessThanEqualGreaterThan = 130,
    LessThanLessThan = 131,
    GreaterThanGreaterThan = 132,
    LessThan = 133,
    GreaterThan = 134,
    LessThanEqual = 135,
    GreaterThanEqual = 136,
    EqualEqual = 137,
    EqualEqualEqual = 138,
    ExclamationEqual = 139,
    ExclamationEqualEqual = 140,
    Carat = 141,
    Bar = 142,
    Ampersand = 143,
    AmpersandAmpersand = 144,
    BarBar = 145,
    Question = 146,
    QuestionAs = 147,
    QuestionColon = 148,
    QuestionQuestion = 149,
    QuestionQuestionEqual = 150,
    Colon = 151,
    Semicolon = 152,
    Equal = 153,
    StarStarEqual = 154,
    StarEqual = 155,
    SlashEqual = 156,
    PercentEqual = 157,
    PlusEqual = 158,
    MinusEqual = 159,
    DotEqual = 160,
    LessThanLessThanEqual = 161,
    GreaterThanGreaterThanEqual = 162,
    AmpersandEqual = 163,
    CaratEqual = 164,
    BarEqual = 165,
    Comma = 166,
    At = 167,
    ColonColon = 168,
    EqualGreaterThan = 169,
    EqualEqualGreaterThan = 170,
    QuestionMinusGreaterThan = 171,
    DotDotDot = 172,
    DollarDollar = 173,
    BarGreaterThan = 174,
    SlashGreaterThan = 175,
    LessThanSlash = 176,
    LessThanQuestion = 177,
    Backtick = 178,
    XHP = 179,
    Hash = 180,
    Readonly = 181,
    Internal = 182,
    // Variable text tokens
    ErrorToken = 183,
    Name = 184,
    Variable = 185,
    DecimalLiteral = 186,
    OctalLiteral = 187,
    HexadecimalLiteral = 188,
    BinaryLiteral = 189,
    FloatingLiteral = 190,
    SingleQuotedStringLiteral = 191,
    DoubleQuotedStringLiteral = 192,
    DoubleQuotedStringLiteralHead = 193,
    StringLiteralBody = 194,
    DoubleQuotedStringLiteralTail = 195,
    HeredocStringLiteral = 196,
    HeredocStringLiteralHead = 197,
    HeredocStringLiteralTail = 198,
    NowdocStringLiteral = 199,
    BooleanLiteral = 200,
    XHPCategoryName = 201,
    XHPElementName = 202,
    XHPClassName = 203,
    XHPStringLiteral = 204,
    XHPBody = 205,
    XHPComment = 206,
    Hashbang = 207,
}

impl TokenKind {
    pub fn to_string(self) -> &'static str {
        match self {
            // No text tokens
            TokenKind::EndOfFile => "end_of_file",
            // Given text tokens
            TokenKind::Abstract => "abstract",
            TokenKind::Arraykey => "arraykey",
            TokenKind::As => "as",
            TokenKind::Async => "async",
            TokenKind::Attribute => "attribute",
            TokenKind::Await => "await",
            TokenKind::Backslash => "\\",
            TokenKind::Binary => "binary",
            TokenKind::Bool => "bool",
            TokenKind::Boolean => "boolean",
            TokenKind::Break => "break",
            TokenKind::Case => "case",
            TokenKind::Catch => "catch",
            TokenKind::Category => "category",
            TokenKind::Children => "children",
            TokenKind::Class => "class",
            TokenKind::Classname => "classname",
            TokenKind::Clone => "clone",
            TokenKind::Const => "const",
            TokenKind::Construct => "__construct",
            TokenKind::Continue => "continue",
            TokenKind::Ctx => "ctx",
            TokenKind::Darray => "darray",
            TokenKind::Default => "default",
            TokenKind::Define => "define",
            TokenKind::Dict => "dict",
            TokenKind::Do => "do",
            TokenKind::Double => "double",
            TokenKind::Echo => "echo",
            TokenKind::Else => "else",
            TokenKind::Empty => "empty",
            TokenKind::Endfor => "endfor",
            TokenKind::Endforeach => "endforeach",
            TokenKind::Endif => "endif",
            TokenKind::Endswitch => "endswitch",
            TokenKind::Endwhile => "endwhile",
            TokenKind::Enum => "enum",
            TokenKind::Eval => "eval",
            TokenKind::Extends => "extends",
            TokenKind::Fallthrough => "fallthrough",
            TokenKind::Float => "float",
            TokenKind::File => "file",
            TokenKind::Final => "final",
            TokenKind::Finally => "finally",
            TokenKind::For => "for",
            TokenKind::Foreach => "foreach",
            TokenKind::From => "from",
            TokenKind::Function => "function",
            TokenKind::Global => "global",
            TokenKind::Concurrent => "concurrent",
            TokenKind::If => "if",
            TokenKind::Implements => "implements",
            TokenKind::Include => "include",
            TokenKind::Include_once => "include_once",
            TokenKind::Inout => "inout",
            TokenKind::Instanceof => "instanceof",
            TokenKind::Insteadof => "insteadof",
            TokenKind::Int => "int",
            TokenKind::Integer => "integer",
            TokenKind::Interface => "interface",
            TokenKind::Is => "is",
            TokenKind::Isset => "isset",
            TokenKind::Keyset => "keyset",
            TokenKind::List => "list",
            TokenKind::Mixed => "mixed",
            TokenKind::Module => "module",
            TokenKind::Namespace => "namespace",
            TokenKind::New => "new",
            TokenKind::Newctx => "newctx",
            TokenKind::Newtype => "newtype",
            TokenKind::Noreturn => "noreturn",
            TokenKind::Num => "num",
            TokenKind::Parent => "parent",
            TokenKind::Print => "print",
            TokenKind::Private => "private",
            TokenKind::Protected => "protected",
            TokenKind::Public => "public",
            TokenKind::Real => "real",
            TokenKind::Reify => "reify",
            TokenKind::Require => "require",
            TokenKind::Require_once => "require_once",
            TokenKind::Required => "required",
            TokenKind::Lateinit => "lateinit",
            TokenKind::Resource => "resource",
            TokenKind::Return => "return",
            TokenKind::SelfToken => "self",
            TokenKind::Shape => "shape",
            TokenKind::Static => "static",
            TokenKind::String => "string",
            TokenKind::Super => "super",
            TokenKind::Switch => "switch",
            TokenKind::This => "this",
            TokenKind::Throw => "throw",
            TokenKind::Trait => "trait",
            TokenKind::Try => "try",
            TokenKind::Tuple => "tuple",
            TokenKind::Type => "type",
            TokenKind::Unset => "unset",
            TokenKind::Upcast => "upcast",
            TokenKind::Use => "use",
            TokenKind::Using => "using",
            TokenKind::Var => "var",
            TokenKind::Varray => "varray",
            TokenKind::Vec => "vec",
            TokenKind::Void => "void",
            TokenKind::With => "with",
            TokenKind::Where => "where",
            TokenKind::While => "while",
            TokenKind::Yield => "yield",
            TokenKind::NullLiteral => "null",
            TokenKind::LeftBracket => "[",
            TokenKind::RightBracket => "]",
            TokenKind::LeftParen => "(",
            TokenKind::RightParen => ")",
            TokenKind::LeftBrace => "{",
            TokenKind::RightBrace => "}",
            TokenKind::Dot => ".",
            TokenKind::MinusGreaterThan => "->",
            TokenKind::PlusPlus => "++",
            TokenKind::MinusMinus => "--",
            TokenKind::StarStar => "**",
            TokenKind::Star => "*",
            TokenKind::Plus => "+",
            TokenKind::Minus => "-",
            TokenKind::Tilde => "~",
            TokenKind::Exclamation => "!",
            TokenKind::Dollar => "$",
            TokenKind::Slash => "/",
            TokenKind::Percent => "%",
            TokenKind::LessThanEqualGreaterThan => "<=>",
            TokenKind::LessThanLessThan => "<<",
            TokenKind::GreaterThanGreaterThan => ">>",
            TokenKind::LessThan => "<",
            TokenKind::GreaterThan => ">",
            TokenKind::LessThanEqual => "<=",
            TokenKind::GreaterThanEqual => ">=",
            TokenKind::EqualEqual => "==",
            TokenKind::EqualEqualEqual => "===",
            TokenKind::ExclamationEqual => "!=",
            TokenKind::ExclamationEqualEqual => "!==",
            TokenKind::Carat => "^",
            TokenKind::Bar => "|",
            TokenKind::Ampersand => "&",
            TokenKind::AmpersandAmpersand => "&&",
            TokenKind::BarBar => "||",
            TokenKind::Question => "?",
            TokenKind::QuestionAs => "?as",
            TokenKind::QuestionColon => "?:",
            TokenKind::QuestionQuestion => "??",
            TokenKind::QuestionQuestionEqual => "??=",
            TokenKind::Colon => ":",
            TokenKind::Semicolon => ";",
            TokenKind::Equal => "=",
            TokenKind::StarStarEqual => "**=",
            TokenKind::StarEqual => "*=",
            TokenKind::SlashEqual => "/=",
            TokenKind::PercentEqual => "%=",
            TokenKind::PlusEqual => "+=",
            TokenKind::MinusEqual => "-=",
            TokenKind::DotEqual => ".=",
            TokenKind::LessThanLessThanEqual => "<<=",
            TokenKind::GreaterThanGreaterThanEqual => ">>=",
            TokenKind::AmpersandEqual => "&=",
            TokenKind::CaratEqual => "^=",
            TokenKind::BarEqual => "|=",
            TokenKind::Comma => ",",
            TokenKind::At => "@",
            TokenKind::ColonColon => "::",
            TokenKind::EqualGreaterThan => "=>",
            TokenKind::EqualEqualGreaterThan => "==>",
            TokenKind::QuestionMinusGreaterThan => "?->",
            TokenKind::DotDotDot => "...",
            TokenKind::DollarDollar => "$$",
            TokenKind::BarGreaterThan => "|>",
            TokenKind::SlashGreaterThan => "/>",
            TokenKind::LessThanSlash => "</",
            TokenKind::LessThanQuestion => "<?",
            TokenKind::Backtick => "`",
            TokenKind::XHP => "xhp",
            TokenKind::Hash => "#",
            TokenKind::Readonly => "readonly",
            TokenKind::Internal => "internal",
            // Variable text tokes
            TokenKind::ErrorToken => "error_token",
            TokenKind::Name => "name",
            TokenKind::Variable => "variable",
            TokenKind::DecimalLiteral => "decimal_literal",
            TokenKind::OctalLiteral => "octal_literal",
            TokenKind::HexadecimalLiteral => "hexadecimal_literal",
            TokenKind::BinaryLiteral => "binary_literal",
            TokenKind::FloatingLiteral => "floating_literal",
            TokenKind::SingleQuotedStringLiteral => "single_quoted_string_literal",
            TokenKind::DoubleQuotedStringLiteral => "double_quoted_string_literal",
            TokenKind::DoubleQuotedStringLiteralHead => "double_quoted_string_literal_head",
            TokenKind::StringLiteralBody => "string_literal_body",
            TokenKind::DoubleQuotedStringLiteralTail => "double_quoted_string_literal_tail",
            TokenKind::HeredocStringLiteral => "heredoc_string_literal",
            TokenKind::HeredocStringLiteralHead => "heredoc_string_literal_head",
            TokenKind::HeredocStringLiteralTail => "heredoc_string_literal_tail",
            TokenKind::NowdocStringLiteral => "nowdoc_string_literal",
            TokenKind::BooleanLiteral => "boolean_literal",
            TokenKind::XHPCategoryName => "XHP_category_name",
            TokenKind::XHPElementName => "XHP_element_name",
            TokenKind::XHPClassName => "XHP_class_name",
            TokenKind::XHPStringLiteral => "XHP_string_literal",
            TokenKind::XHPBody => "XHP_body",
            TokenKind::XHPComment => "XHP_comment",
            TokenKind::Hashbang => "hashbang",
        }
    }

    pub fn from_string(
        keyword: &[u8],
        only_reserved: bool,
    ) -> Option<Self> {
        let keyword = unsafe { std::str::from_utf8_unchecked(keyword) };
        match keyword {
            "true" if !only_reserved => Some(TokenKind::BooleanLiteral),
            "false" if !only_reserved => Some(TokenKind::BooleanLiteral),
            "abstract" => Some(TokenKind::Abstract),
            "arraykey" if !only_reserved => Some(TokenKind::Arraykey),
            "as" => Some(TokenKind::As),
            "async" => Some(TokenKind::Async),
            "attribute" if !only_reserved => Some(TokenKind::Attribute),
            "await" => Some(TokenKind::Await),
            "\\" => Some(TokenKind::Backslash),
            "binary" if !only_reserved => Some(TokenKind::Binary),
            "bool" if !only_reserved => Some(TokenKind::Bool),
            "boolean" if !only_reserved => Some(TokenKind::Boolean),
            "break" => Some(TokenKind::Break),
            "case" => Some(TokenKind::Case),
            "catch" => Some(TokenKind::Catch),
            "category" if !only_reserved => Some(TokenKind::Category),
            "children" if !only_reserved => Some(TokenKind::Children),
            "class" => Some(TokenKind::Class),
            "classname" if !only_reserved => Some(TokenKind::Classname),
            "clone" => Some(TokenKind::Clone),
            "const" => Some(TokenKind::Const),
            "__construct" => Some(TokenKind::Construct),
            "continue" => Some(TokenKind::Continue),
            "ctx" => Some(TokenKind::Ctx),
            "darray" if !only_reserved => Some(TokenKind::Darray),
            "default" => Some(TokenKind::Default),
            "define" if !only_reserved => Some(TokenKind::Define),
            "dict" if !only_reserved => Some(TokenKind::Dict),
            "do" => Some(TokenKind::Do),
            "double" if !only_reserved => Some(TokenKind::Double),
            "echo" => Some(TokenKind::Echo),
            "else" => Some(TokenKind::Else),
            "empty" => Some(TokenKind::Empty),
            "endfor" => Some(TokenKind::Endfor),
            "endforeach" => Some(TokenKind::Endforeach),
            "endif" => Some(TokenKind::Endif),
            "endswitch" => Some(TokenKind::Endswitch),
            "endwhile" => Some(TokenKind::Endwhile),
            "enum" if !only_reserved => Some(TokenKind::Enum),
            "eval" => Some(TokenKind::Eval),
            "extends" => Some(TokenKind::Extends),
            "fallthrough" if !only_reserved => Some(TokenKind::Fallthrough),
            "float" if !only_reserved => Some(TokenKind::Float),
            "file" if !only_reserved => Some(TokenKind::File),
            "final" => Some(TokenKind::Final),
            "finally" => Some(TokenKind::Finally),
            "for" => Some(TokenKind::For),
            "foreach" => Some(TokenKind::Foreach),
            "from" if !only_reserved => Some(TokenKind::From),
            "function" => Some(TokenKind::Function),
            "global" => Some(TokenKind::Global),
            "concurrent" => Some(TokenKind::Concurrent),
            "if" => Some(TokenKind::If),
            "implements" => Some(TokenKind::Implements),
            "include" => Some(TokenKind::Include),
            "include_once" => Some(TokenKind::Include_once),
            "inout" => Some(TokenKind::Inout),
            "instanceof" => Some(TokenKind::Instanceof),
            "insteadof" => Some(TokenKind::Insteadof),
            "int" if !only_reserved => Some(TokenKind::Int),
            "integer" if !only_reserved => Some(TokenKind::Integer),
            "interface" => Some(TokenKind::Interface),
            "is" if !only_reserved => Some(TokenKind::Is),
            "isset" => Some(TokenKind::Isset),
            "keyset" if !only_reserved => Some(TokenKind::Keyset),
            "list" => Some(TokenKind::List),
            "mixed" if !only_reserved => Some(TokenKind::Mixed),
            "module" => Some(TokenKind::Module),
            "namespace" => Some(TokenKind::Namespace),
            "new" => Some(TokenKind::New),
            "newctx" if !only_reserved => Some(TokenKind::Newctx),
            "newtype" if !only_reserved => Some(TokenKind::Newtype),
            "noreturn" if !only_reserved => Some(TokenKind::Noreturn),
            "num" if !only_reserved => Some(TokenKind::Num),
            "parent" if !only_reserved => Some(TokenKind::Parent),
            "print" => Some(TokenKind::Print),
            "private" => Some(TokenKind::Private),
            "protected" => Some(TokenKind::Protected),
            "public" => Some(TokenKind::Public),
            "real" if !only_reserved => Some(TokenKind::Real),
            "reify" if !only_reserved => Some(TokenKind::Reify),
            "require" => Some(TokenKind::Require),
            "require_once" => Some(TokenKind::Require_once),
            "required" => Some(TokenKind::Required),
            "lateinit" => Some(TokenKind::Lateinit),
            "resource" if !only_reserved => Some(TokenKind::Resource),
            "return" => Some(TokenKind::Return),
            "self" if !only_reserved => Some(TokenKind::SelfToken),
            "shape" => Some(TokenKind::Shape),
            "static" => Some(TokenKind::Static),
            "string" if !only_reserved => Some(TokenKind::String),
            "super" if !only_reserved => Some(TokenKind::Super),
            "switch" => Some(TokenKind::Switch),
            "this" if !only_reserved => Some(TokenKind::This),
            "throw" => Some(TokenKind::Throw),
            "trait" => Some(TokenKind::Trait),
            "try" => Some(TokenKind::Try),
            "tuple" => Some(TokenKind::Tuple),
            "type" if !only_reserved => Some(TokenKind::Type),
            "unset" => Some(TokenKind::Unset),
            "upcast" if !only_reserved => Some(TokenKind::Upcast),
            "use" => Some(TokenKind::Use),
            "using" => Some(TokenKind::Using),
            "var" => Some(TokenKind::Var),
            "varray" if !only_reserved => Some(TokenKind::Varray),
            "vec" if !only_reserved => Some(TokenKind::Vec),
            "void" if !only_reserved => Some(TokenKind::Void),
            "with" if !only_reserved => Some(TokenKind::With),
            "where" if !only_reserved => Some(TokenKind::Where),
            "while" => Some(TokenKind::While),
            "yield" => Some(TokenKind::Yield),
            "null" if !only_reserved => Some(TokenKind::NullLiteral),
            "[" => Some(TokenKind::LeftBracket),
            "]" => Some(TokenKind::RightBracket),
            "(" => Some(TokenKind::LeftParen),
            ")" => Some(TokenKind::RightParen),
            "{" => Some(TokenKind::LeftBrace),
            "}" => Some(TokenKind::RightBrace),
            "." => Some(TokenKind::Dot),
            "->" => Some(TokenKind::MinusGreaterThan),
            "++" => Some(TokenKind::PlusPlus),
            "--" => Some(TokenKind::MinusMinus),
            "**" => Some(TokenKind::StarStar),
            "*" => Some(TokenKind::Star),
            "+" => Some(TokenKind::Plus),
            "-" => Some(TokenKind::Minus),
            "~" => Some(TokenKind::Tilde),
            "!" => Some(TokenKind::Exclamation),
            "$" => Some(TokenKind::Dollar),
            "/" => Some(TokenKind::Slash),
            "%" => Some(TokenKind::Percent),
            "<=>" => Some(TokenKind::LessThanEqualGreaterThan),
            "<<" => Some(TokenKind::LessThanLessThan),
            ">>" => Some(TokenKind::GreaterThanGreaterThan),
            "<" => Some(TokenKind::LessThan),
            ">" => Some(TokenKind::GreaterThan),
            "<=" => Some(TokenKind::LessThanEqual),
            ">=" => Some(TokenKind::GreaterThanEqual),
            "==" => Some(TokenKind::EqualEqual),
            "===" => Some(TokenKind::EqualEqualEqual),
            "!=" => Some(TokenKind::ExclamationEqual),
            "!==" => Some(TokenKind::ExclamationEqualEqual),
            "^" => Some(TokenKind::Carat),
            "|" => Some(TokenKind::Bar),
            "&" => Some(TokenKind::Ampersand),
            "&&" => Some(TokenKind::AmpersandAmpersand),
            "||" => Some(TokenKind::BarBar),
            "?" => Some(TokenKind::Question),
            "?as" => Some(TokenKind::QuestionAs),
            "?:" => Some(TokenKind::QuestionColon),
            "??" => Some(TokenKind::QuestionQuestion),
            "??=" => Some(TokenKind::QuestionQuestionEqual),
            ":" => Some(TokenKind::Colon),
            ";" => Some(TokenKind::Semicolon),
            "=" => Some(TokenKind::Equal),
            "**=" => Some(TokenKind::StarStarEqual),
            "*=" => Some(TokenKind::StarEqual),
            "/=" => Some(TokenKind::SlashEqual),
            "%=" => Some(TokenKind::PercentEqual),
            "+=" => Some(TokenKind::PlusEqual),
            "-=" => Some(TokenKind::MinusEqual),
            ".=" => Some(TokenKind::DotEqual),
            "<<=" => Some(TokenKind::LessThanLessThanEqual),
            ">>=" => Some(TokenKind::GreaterThanGreaterThanEqual),
            "&=" => Some(TokenKind::AmpersandEqual),
            "^=" => Some(TokenKind::CaratEqual),
            "|=" => Some(TokenKind::BarEqual),
            "," => Some(TokenKind::Comma),
            "@" => Some(TokenKind::At),
            "::" => Some(TokenKind::ColonColon),
            "=>" => Some(TokenKind::EqualGreaterThan),
            "==>" => Some(TokenKind::EqualEqualGreaterThan),
            "?->" => Some(TokenKind::QuestionMinusGreaterThan),
            "..." => Some(TokenKind::DotDotDot),
            "$$" => Some(TokenKind::DollarDollar),
            "|>" => Some(TokenKind::BarGreaterThan),
            "/>" => Some(TokenKind::SlashGreaterThan),
            "</" => Some(TokenKind::LessThanSlash),
            "<?" => Some(TokenKind::LessThanQuestion),
            "`" => Some(TokenKind::Backtick),
            "xhp" if !only_reserved => Some(TokenKind::XHP),
            "#" => Some(TokenKind::Hash),
            "readonly" => Some(TokenKind::Readonly),
            "internal" if !only_reserved => Some(TokenKind::Internal),
            _ => None,
        }
    }

    pub fn ocaml_tag(self) -> u8 {
        match self {
            TokenKind::EndOfFile => 0,
            TokenKind::Abstract => 1,
            TokenKind::Arraykey => 2,
            TokenKind::As => 3,
            TokenKind::Async => 4,
            TokenKind::Attribute => 5,
            TokenKind::Await => 6,
            TokenKind::Backslash => 7,
            TokenKind::Binary => 8,
            TokenKind::Bool => 9,
            TokenKind::Boolean => 10,
            TokenKind::Break => 11,
            TokenKind::Case => 12,
            TokenKind::Catch => 13,
            TokenKind::Category => 14,
            TokenKind::Children => 15,
            TokenKind::Class => 16,
            TokenKind::Classname => 17,
            TokenKind::Clone => 18,
            TokenKind::Const => 19,
            TokenKind::Construct => 20,
            TokenKind::Continue => 21,
            TokenKind::Ctx => 22,
            TokenKind::Darray => 23,
            TokenKind::Default => 24,
            TokenKind::Define => 25,
            TokenKind::Dict => 26,
            TokenKind::Do => 27,
            TokenKind::Double => 28,
            TokenKind::Echo => 29,
            TokenKind::Else => 30,
            TokenKind::Empty => 31,
            TokenKind::Endfor => 32,
            TokenKind::Endforeach => 33,
            TokenKind::Endif => 34,
            TokenKind::Endswitch => 35,
            TokenKind::Endwhile => 36,
            TokenKind::Enum => 37,
            TokenKind::Eval => 38,
            TokenKind::Extends => 39,
            TokenKind::Fallthrough => 40,
            TokenKind::Float => 41,
            TokenKind::File => 42,
            TokenKind::Final => 43,
            TokenKind::Finally => 44,
            TokenKind::For => 45,
            TokenKind::Foreach => 46,
            TokenKind::From => 47,
            TokenKind::Function => 48,
            TokenKind::Global => 49,
            TokenKind::Concurrent => 50,
            TokenKind::If => 51,
            TokenKind::Implements => 52,
            TokenKind::Include => 53,
            TokenKind::Include_once => 54,
            TokenKind::Inout => 55,
            TokenKind::Instanceof => 56,
            TokenKind::Insteadof => 57,
            TokenKind::Int => 58,
            TokenKind::Integer => 59,
            TokenKind::Interface => 60,
            TokenKind::Is => 61,
            TokenKind::Isset => 62,
            TokenKind::Keyset => 63,
            TokenKind::List => 64,
            TokenKind::Mixed => 65,
            TokenKind::Module => 66,
            TokenKind::Namespace => 67,
            TokenKind::New => 68,
            TokenKind::Newctx => 69,
            TokenKind::Newtype => 70,
            TokenKind::Noreturn => 71,
            TokenKind::Num => 72,
            TokenKind::Parent => 73,
            TokenKind::Print => 74,
            TokenKind::Private => 75,
            TokenKind::Protected => 76,
            TokenKind::Public => 77,
            TokenKind::Real => 78,
            TokenKind::Reify => 79,
            TokenKind::Require => 80,
            TokenKind::Require_once => 81,
            TokenKind::Required => 82,
            TokenKind::Lateinit => 83,
            TokenKind::Resource => 84,
            TokenKind::Return => 85,
            TokenKind::SelfToken => 86,
            TokenKind::Shape => 87,
            TokenKind::Static => 88,
            TokenKind::String => 89,
            TokenKind::Super => 90,
            TokenKind::Switch => 91,
            TokenKind::This => 92,
            TokenKind::Throw => 93,
            TokenKind::Trait => 94,
            TokenKind::Try => 95,
            TokenKind::Tuple => 96,
            TokenKind::Type => 97,
            TokenKind::Unset => 98,
            TokenKind::Upcast => 99,
            TokenKind::Use => 100,
            TokenKind::Using => 101,
            TokenKind::Var => 102,
            TokenKind::Varray => 103,
            TokenKind::Vec => 104,
            TokenKind::Void => 105,
            TokenKind::With => 106,
            TokenKind::Where => 107,
            TokenKind::While => 108,
            TokenKind::Yield => 109,
            TokenKind::NullLiteral => 110,
            TokenKind::LeftBracket => 111,
            TokenKind::RightBracket => 112,
            TokenKind::LeftParen => 113,
            TokenKind::RightParen => 114,
            TokenKind::LeftBrace => 115,
            TokenKind::RightBrace => 116,
            TokenKind::Dot => 117,
            TokenKind::MinusGreaterThan => 118,
            TokenKind::PlusPlus => 119,
            TokenKind::MinusMinus => 120,
            TokenKind::StarStar => 121,
            TokenKind::Star => 122,
            TokenKind::Plus => 123,
            TokenKind::Minus => 124,
            TokenKind::Tilde => 125,
            TokenKind::Exclamation => 126,
            TokenKind::Dollar => 127,
            TokenKind::Slash => 128,
            TokenKind::Percent => 129,
            TokenKind::LessThanEqualGreaterThan => 130,
            TokenKind::LessThanLessThan => 131,
            TokenKind::GreaterThanGreaterThan => 132,
            TokenKind::LessThan => 133,
            TokenKind::GreaterThan => 134,
            TokenKind::LessThanEqual => 135,
            TokenKind::GreaterThanEqual => 136,
            TokenKind::EqualEqual => 137,
            TokenKind::EqualEqualEqual => 138,
            TokenKind::ExclamationEqual => 139,
            TokenKind::ExclamationEqualEqual => 140,
            TokenKind::Carat => 141,
            TokenKind::Bar => 142,
            TokenKind::Ampersand => 143,
            TokenKind::AmpersandAmpersand => 144,
            TokenKind::BarBar => 145,
            TokenKind::Question => 146,
            TokenKind::QuestionAs => 147,
            TokenKind::QuestionColon => 148,
            TokenKind::QuestionQuestion => 149,
            TokenKind::QuestionQuestionEqual => 150,
            TokenKind::Colon => 151,
            TokenKind::Semicolon => 152,
            TokenKind::Equal => 153,
            TokenKind::StarStarEqual => 154,
            TokenKind::StarEqual => 155,
            TokenKind::SlashEqual => 156,
            TokenKind::PercentEqual => 157,
            TokenKind::PlusEqual => 158,
            TokenKind::MinusEqual => 159,
            TokenKind::DotEqual => 160,
            TokenKind::LessThanLessThanEqual => 161,
            TokenKind::GreaterThanGreaterThanEqual => 162,
            TokenKind::AmpersandEqual => 163,
            TokenKind::CaratEqual => 164,
            TokenKind::BarEqual => 165,
            TokenKind::Comma => 166,
            TokenKind::At => 167,
            TokenKind::ColonColon => 168,
            TokenKind::EqualGreaterThan => 169,
            TokenKind::EqualEqualGreaterThan => 170,
            TokenKind::QuestionMinusGreaterThan => 171,
            TokenKind::DotDotDot => 172,
            TokenKind::DollarDollar => 173,
            TokenKind::BarGreaterThan => 174,
            TokenKind::SlashGreaterThan => 175,
            TokenKind::LessThanSlash => 176,
            TokenKind::LessThanQuestion => 177,
            TokenKind::Backtick => 178,
            TokenKind::XHP => 179,
            TokenKind::Hash => 180,
            TokenKind::Readonly => 181,
            TokenKind::Internal => 182,
            TokenKind::ErrorToken => 183,
            TokenKind::Name => 184,
            TokenKind::Variable => 185,
            TokenKind::DecimalLiteral => 186,
            TokenKind::OctalLiteral => 187,
            TokenKind::HexadecimalLiteral => 188,
            TokenKind::BinaryLiteral => 189,
            TokenKind::FloatingLiteral => 190,
            TokenKind::SingleQuotedStringLiteral => 191,
            TokenKind::DoubleQuotedStringLiteral => 192,
            TokenKind::DoubleQuotedStringLiteralHead => 193,
            TokenKind::StringLiteralBody => 194,
            TokenKind::DoubleQuotedStringLiteralTail => 195,
            TokenKind::HeredocStringLiteral => 196,
            TokenKind::HeredocStringLiteralHead => 197,
            TokenKind::HeredocStringLiteralTail => 198,
            TokenKind::NowdocStringLiteral => 199,
            TokenKind::BooleanLiteral => 200,
            TokenKind::XHPCategoryName => 201,
            TokenKind::XHPElementName => 202,
            TokenKind::XHPClassName => 203,
            TokenKind::XHPStringLiteral => 204,
            TokenKind::XHPBody => 205,
            TokenKind::XHPComment => 206,
            TokenKind::Hashbang => 207,
        }
    }

    pub fn try_from_u8(tag: u8) -> Option<Self> {
        match tag {
            0 => Some(TokenKind::EndOfFile),
            1 => Some(TokenKind::Abstract),
            2 => Some(TokenKind::Arraykey),
            3 => Some(TokenKind::As),
            4 => Some(TokenKind::Async),
            5 => Some(TokenKind::Attribute),
            6 => Some(TokenKind::Await),
            7 => Some(TokenKind::Backslash),
            8 => Some(TokenKind::Binary),
            9 => Some(TokenKind::Bool),
            10 => Some(TokenKind::Boolean),
            11 => Some(TokenKind::Break),
            12 => Some(TokenKind::Case),
            13 => Some(TokenKind::Catch),
            14 => Some(TokenKind::Category),
            15 => Some(TokenKind::Children),
            16 => Some(TokenKind::Class),
            17 => Some(TokenKind::Classname),
            18 => Some(TokenKind::Clone),
            19 => Some(TokenKind::Const),
            20 => Some(TokenKind::Construct),
            21 => Some(TokenKind::Continue),
            22 => Some(TokenKind::Ctx),
            23 => Some(TokenKind::Darray),
            24 => Some(TokenKind::Default),
            25 => Some(TokenKind::Define),
            26 => Some(TokenKind::Dict),
            27 => Some(TokenKind::Do),
            28 => Some(TokenKind::Double),
            29 => Some(TokenKind::Echo),
            30 => Some(TokenKind::Else),
            31 => Some(TokenKind::Empty),
            32 => Some(TokenKind::Endfor),
            33 => Some(TokenKind::Endforeach),
            34 => Some(TokenKind::Endif),
            35 => Some(TokenKind::Endswitch),
            36 => Some(TokenKind::Endwhile),
            37 => Some(TokenKind::Enum),
            38 => Some(TokenKind::Eval),
            39 => Some(TokenKind::Extends),
            40 => Some(TokenKind::Fallthrough),
            41 => Some(TokenKind::Float),
            42 => Some(TokenKind::File),
            43 => Some(TokenKind::Final),
            44 => Some(TokenKind::Finally),
            45 => Some(TokenKind::For),
            46 => Some(TokenKind::Foreach),
            47 => Some(TokenKind::From),
            48 => Some(TokenKind::Function),
            49 => Some(TokenKind::Global),
            50 => Some(TokenKind::Concurrent),
            51 => Some(TokenKind::If),
            52 => Some(TokenKind::Implements),
            53 => Some(TokenKind::Include),
            54 => Some(TokenKind::Include_once),
            55 => Some(TokenKind::Inout),
            56 => Some(TokenKind::Instanceof),
            57 => Some(TokenKind::Insteadof),
            58 => Some(TokenKind::Int),
            59 => Some(TokenKind::Integer),
            60 => Some(TokenKind::Interface),
            61 => Some(TokenKind::Is),
            62 => Some(TokenKind::Isset),
            63 => Some(TokenKind::Keyset),
            64 => Some(TokenKind::List),
            65 => Some(TokenKind::Mixed),
            66 => Some(TokenKind::Module),
            67 => Some(TokenKind::Namespace),
            68 => Some(TokenKind::New),
            69 => Some(TokenKind::Newctx),
            70 => Some(TokenKind::Newtype),
            71 => Some(TokenKind::Noreturn),
            72 => Some(TokenKind::Num),
            73 => Some(TokenKind::Parent),
            74 => Some(TokenKind::Print),
            75 => Some(TokenKind::Private),
            76 => Some(TokenKind::Protected),
            77 => Some(TokenKind::Public),
            78 => Some(TokenKind::Real),
            79 => Some(TokenKind::Reify),
            80 => Some(TokenKind::Require),
            81 => Some(TokenKind::Require_once),
            82 => Some(TokenKind::Required),
            83 => Some(TokenKind::Lateinit),
            84 => Some(TokenKind::Resource),
            85 => Some(TokenKind::Return),
            86 => Some(TokenKind::SelfToken),
            87 => Some(TokenKind::Shape),
            88 => Some(TokenKind::Static),
            89 => Some(TokenKind::String),
            90 => Some(TokenKind::Super),
            91 => Some(TokenKind::Switch),
            92 => Some(TokenKind::This),
            93 => Some(TokenKind::Throw),
            94 => Some(TokenKind::Trait),
            95 => Some(TokenKind::Try),
            96 => Some(TokenKind::Tuple),
            97 => Some(TokenKind::Type),
            98 => Some(TokenKind::Unset),
            99 => Some(TokenKind::Upcast),
            100 => Some(TokenKind::Use),
            101 => Some(TokenKind::Using),
            102 => Some(TokenKind::Var),
            103 => Some(TokenKind::Varray),
            104 => Some(TokenKind::Vec),
            105 => Some(TokenKind::Void),
            106 => Some(TokenKind::With),
            107 => Some(TokenKind::Where),
            108 => Some(TokenKind::While),
            109 => Some(TokenKind::Yield),
            110 => Some(TokenKind::NullLiteral),
            111 => Some(TokenKind::LeftBracket),
            112 => Some(TokenKind::RightBracket),
            113 => Some(TokenKind::LeftParen),
            114 => Some(TokenKind::RightParen),
            115 => Some(TokenKind::LeftBrace),
            116 => Some(TokenKind::RightBrace),
            117 => Some(TokenKind::Dot),
            118 => Some(TokenKind::MinusGreaterThan),
            119 => Some(TokenKind::PlusPlus),
            120 => Some(TokenKind::MinusMinus),
            121 => Some(TokenKind::StarStar),
            122 => Some(TokenKind::Star),
            123 => Some(TokenKind::Plus),
            124 => Some(TokenKind::Minus),
            125 => Some(TokenKind::Tilde),
            126 => Some(TokenKind::Exclamation),
            127 => Some(TokenKind::Dollar),
            128 => Some(TokenKind::Slash),
            129 => Some(TokenKind::Percent),
            130 => Some(TokenKind::LessThanEqualGreaterThan),
            131 => Some(TokenKind::LessThanLessThan),
            132 => Some(TokenKind::GreaterThanGreaterThan),
            133 => Some(TokenKind::LessThan),
            134 => Some(TokenKind::GreaterThan),
            135 => Some(TokenKind::LessThanEqual),
            136 => Some(TokenKind::GreaterThanEqual),
            137 => Some(TokenKind::EqualEqual),
            138 => Some(TokenKind::EqualEqualEqual),
            139 => Some(TokenKind::ExclamationEqual),
            140 => Some(TokenKind::ExclamationEqualEqual),
            141 => Some(TokenKind::Carat),
            142 => Some(TokenKind::Bar),
            143 => Some(TokenKind::Ampersand),
            144 => Some(TokenKind::AmpersandAmpersand),
            145 => Some(TokenKind::BarBar),
            146 => Some(TokenKind::Question),
            147 => Some(TokenKind::QuestionAs),
            148 => Some(TokenKind::QuestionColon),
            149 => Some(TokenKind::QuestionQuestion),
            150 => Some(TokenKind::QuestionQuestionEqual),
            151 => Some(TokenKind::Colon),
            152 => Some(TokenKind::Semicolon),
            153 => Some(TokenKind::Equal),
            154 => Some(TokenKind::StarStarEqual),
            155 => Some(TokenKind::StarEqual),
            156 => Some(TokenKind::SlashEqual),
            157 => Some(TokenKind::PercentEqual),
            158 => Some(TokenKind::PlusEqual),
            159 => Some(TokenKind::MinusEqual),
            160 => Some(TokenKind::DotEqual),
            161 => Some(TokenKind::LessThanLessThanEqual),
            162 => Some(TokenKind::GreaterThanGreaterThanEqual),
            163 => Some(TokenKind::AmpersandEqual),
            164 => Some(TokenKind::CaratEqual),
            165 => Some(TokenKind::BarEqual),
            166 => Some(TokenKind::Comma),
            167 => Some(TokenKind::At),
            168 => Some(TokenKind::ColonColon),
            169 => Some(TokenKind::EqualGreaterThan),
            170 => Some(TokenKind::EqualEqualGreaterThan),
            171 => Some(TokenKind::QuestionMinusGreaterThan),
            172 => Some(TokenKind::DotDotDot),
            173 => Some(TokenKind::DollarDollar),
            174 => Some(TokenKind::BarGreaterThan),
            175 => Some(TokenKind::SlashGreaterThan),
            176 => Some(TokenKind::LessThanSlash),
            177 => Some(TokenKind::LessThanQuestion),
            178 => Some(TokenKind::Backtick),
            179 => Some(TokenKind::XHP),
            180 => Some(TokenKind::Hash),
            181 => Some(TokenKind::Readonly),
            182 => Some(TokenKind::Internal),
            183 => Some(TokenKind::ErrorToken),
            184 => Some(TokenKind::Name),
            185 => Some(TokenKind::Variable),
            186 => Some(TokenKind::DecimalLiteral),
            187 => Some(TokenKind::OctalLiteral),
            188 => Some(TokenKind::HexadecimalLiteral),
            189 => Some(TokenKind::BinaryLiteral),
            190 => Some(TokenKind::FloatingLiteral),
            191 => Some(TokenKind::SingleQuotedStringLiteral),
            192 => Some(TokenKind::DoubleQuotedStringLiteral),
            193 => Some(TokenKind::DoubleQuotedStringLiteralHead),
            194 => Some(TokenKind::StringLiteralBody),
            195 => Some(TokenKind::DoubleQuotedStringLiteralTail),
            196 => Some(TokenKind::HeredocStringLiteral),
            197 => Some(TokenKind::HeredocStringLiteralHead),
            198 => Some(TokenKind::HeredocStringLiteralTail),
            199 => Some(TokenKind::NowdocStringLiteral),
            200 => Some(TokenKind::BooleanLiteral),
            201 => Some(TokenKind::XHPCategoryName),
            202 => Some(TokenKind::XHPElementName),
            203 => Some(TokenKind::XHPClassName),
            204 => Some(TokenKind::XHPStringLiteral),
            205 => Some(TokenKind::XHPBody),
            206 => Some(TokenKind::XHPComment),
            207 => Some(TokenKind::Hashbang),
            _ => None,
        }
    }

    pub fn fixed_width(self) -> Option<NonZeroUsize> {
        match self {
            TokenKind::Abstract => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Arraykey => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::As => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::Async => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Attribute => Some(unsafe { NonZeroUsize::new_unchecked(9) }),
            TokenKind::Await => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Backslash => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Binary => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Bool => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Boolean => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::Break => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Case => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Catch => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Category => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Children => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Class => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Classname => Some(unsafe { NonZeroUsize::new_unchecked(9) }),
            TokenKind::Clone => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Const => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Construct => Some(unsafe { NonZeroUsize::new_unchecked(11) }),
            TokenKind::Continue => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Ctx => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Darray => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Default => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::Define => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Dict => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Do => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::Double => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Echo => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Else => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Empty => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Endfor => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Endforeach => Some(unsafe { NonZeroUsize::new_unchecked(10) }),
            TokenKind::Endif => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Endswitch => Some(unsafe { NonZeroUsize::new_unchecked(9) }),
            TokenKind::Endwhile => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Enum => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Eval => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Extends => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::Fallthrough => Some(unsafe { NonZeroUsize::new_unchecked(11) }),
            TokenKind::Float => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::File => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Final => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Finally => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::For => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Foreach => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::From => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Function => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Global => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Concurrent => Some(unsafe { NonZeroUsize::new_unchecked(10) }),
            TokenKind::If => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::Implements => Some(unsafe { NonZeroUsize::new_unchecked(10) }),
            TokenKind::Include => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::Include_once => Some(unsafe { NonZeroUsize::new_unchecked(12) }),
            TokenKind::Inout => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Instanceof => Some(unsafe { NonZeroUsize::new_unchecked(10) }),
            TokenKind::Insteadof => Some(unsafe { NonZeroUsize::new_unchecked(9) }),
            TokenKind::Int => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Integer => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::Interface => Some(unsafe { NonZeroUsize::new_unchecked(9) }),
            TokenKind::Is => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::Isset => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Keyset => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::List => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Mixed => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Module => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Namespace => Some(unsafe { NonZeroUsize::new_unchecked(9) }),
            TokenKind::New => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Newctx => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Newtype => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::Noreturn => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Num => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Parent => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Print => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Private => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::Protected => Some(unsafe { NonZeroUsize::new_unchecked(9) }),
            TokenKind::Public => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Real => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Reify => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Require => Some(unsafe { NonZeroUsize::new_unchecked(7) }),
            TokenKind::Require_once => Some(unsafe { NonZeroUsize::new_unchecked(12) }),
            TokenKind::Required => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Lateinit => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Resource => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Return => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::SelfToken => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Shape => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Static => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::String => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Super => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Switch => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::This => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Throw => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Trait => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Try => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Tuple => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Type => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Unset => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Upcast => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Use => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Using => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Var => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Varray => Some(unsafe { NonZeroUsize::new_unchecked(6) }),
            TokenKind::Vec => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Void => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::With => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::Where => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::While => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::Yield => Some(unsafe { NonZeroUsize::new_unchecked(5) }),
            TokenKind::NullLiteral => Some(unsafe { NonZeroUsize::new_unchecked(4) }),
            TokenKind::LeftBracket => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::RightBracket => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::LeftParen => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::RightParen => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::LeftBrace => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::RightBrace => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Dot => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::MinusGreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::PlusPlus => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::MinusMinus => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::StarStar => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::Star => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Plus => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Minus => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Tilde => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Exclamation => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Dollar => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Slash => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Percent => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::LessThanEqualGreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::LessThanLessThan => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::GreaterThanGreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::LessThan => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::GreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::LessThanEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::GreaterThanEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::EqualEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::EqualEqualEqual => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::ExclamationEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::ExclamationEqualEqual => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Carat => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Bar => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Ampersand => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::AmpersandAmpersand => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::BarBar => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::Question => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::QuestionAs => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::QuestionColon => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::QuestionQuestion => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::QuestionQuestionEqual => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Colon => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Semicolon => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Equal => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::StarStarEqual => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::StarEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::SlashEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::PercentEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::PlusEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::MinusEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::DotEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::LessThanLessThanEqual => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::GreaterThanGreaterThanEqual => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::AmpersandEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::CaratEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::BarEqual => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::Comma => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::At => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::ColonColon => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::EqualGreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::EqualEqualGreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::QuestionMinusGreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::DotDotDot => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::DollarDollar => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::BarGreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::SlashGreaterThan => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::LessThanSlash => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::LessThanQuestion => Some(unsafe { NonZeroUsize::new_unchecked(2) }),
            TokenKind::Backtick => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::XHP => Some(unsafe { NonZeroUsize::new_unchecked(3) }),
            TokenKind::Hash => Some(unsafe { NonZeroUsize::new_unchecked(1) }),
            TokenKind::Readonly => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            TokenKind::Internal => Some(unsafe { NonZeroUsize::new_unchecked(8) }),
            _ => None,
        }
    }
}
